#ifndef _KERN_LOCK_H
#define _KERN_LOCK_H

#include <kern/kernel.h>
#include <kern/spinlock.h>
#include <kern/sched.h>
#include <util/spinlock.h>

namespace Lock {
	extern int dying;

	struct Lock {
		SpinLock spinlock;
		Threads::WaitQueue waitqueue;
		ulong lockval;
		
		Lock()
		{
			lockval = 0;
		}
		
		void lock();
		void unlock();

		// Include kern/thread.h for inline definition
		bool held_by_curthread();
	};
}

#endif
